#!/bin/bash

#PIN=$(cat /proc/device-tree/repka-pinout)
#FREQ=$(cat /proc/device-tree/repka-freq)


whiptail --title "Текущая максимальная частота и объем оперативной памяти"  --msgbox "$(lscpu | grep "max") \n"Объем_оперативной_памяти" $(grep MemTotal /proc/meminfo | awk '{print $2 / 1024}') "Мегабайт"" 0 0

#222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222


Ubuntu_update() {
  apt-get update &&
  apt-get upgrade &&
  printf "Ожидаем 5 секунд до повторного запуска repka-config\n" &&
  sleep 5 &&
  exec repka-config
}

Repka_OS_update() {
	rm /tmp/repka-os-version
	wget -nd -P /tmp https://download.robointellect.ru/repka-pi3/repka-os/repka-os-version
	CHECK_REPKA_OS_VERSION=$( cat /tmp/repka-os-version )

 	if (whiptail --title "Обновление Repka OS" --yesno "Текущая версия   $( cat ../usr/local/repka-os-version ) \nДоступная версия $CHECK_REPKA_OS_VERSION \n\n			Установить? " 10 50) then
	CHECK_REPKA_OS_VERSION=${CHECK_REPKA_OS_VERSION:9}

	wget -nd -P /tmp https://download.robointellect.ru/repka-pi3/repka-os/repka-pi3-update-$CHECK_REPKA_OS_VERSION.deb
	dpkg --force-overwrite -i /tmp/repka-pi3-update-$CHECK_REPKA_OS_VERSION.deb
	 /usr/local/repka-wallpaper/repka-wallpaper
	rm /tmp/repka-pi3-update-$CHECK_REPKA_OS_VERSION.deb
	
	else
	     return 0
	fi	

}

Kernel_update () {
  wget -O - https://download.robointellect.ru/repka-pi3/kernel-update.sh | bash
  return 0
}


DRAM_CLK_672() {
dd if=../boot/spl/u-boot-sunxi-with-spl-dram-672.bin of=../dev/mmcblk0 bs=1024 seek=8 conv=notrunc
}

DRAM_CLK_696() {
dd if=../boot/spl/u-boot-sunxi-with-spl-dram-696.bin of=../dev/mmcblk0 bs=1024 seek=8 conv=notrunc
}

DRAM_CLK_744() {
dd if=../boot/spl/u-boot-sunxi-with-spl-dram-744.bin of=../dev/mmcblk0 bs=1024 seek=8 conv=notrunc
}

DRAM_CLK_768() {
dd if=../boot/spl/u-boot-sunxi-with-spl-dram-768.bin of=../dev/mmcblk0 bs=1024 seek=8 conv=notrunc
}

boot_tty6() {
cp /boot/boot-tty6.scr /boot/boot.scr
dd if=../boot/spl/u-boot-sunxi-with-spl-dram-672-nottys0.bin of=../dev/mmcblk0 bs=1024 seek=8 conv=notrunc
}

boot_ttyS0() {
cp /boot/boot-ttyS0.scr /boot/boot.scr
dd if=../boot/spl/u-boot-sunxi-with-spl-dram-672.bin of=../dev/mmcblk0 bs=1024 seek=8 conv=notrunc
}



freq_1() {
 
	OPTION_F1=$(whiptail --title "Максимальная частота 1 GHz" --menu "Выберите вариант распиновки портов Repka-Pi" 15 80 8 \
	"1 Вариант" "  - GPIO-26, UART-1 (По умолчанию) " \
	"2 Вариант" "  - GPIO-15, UART-1, SPI-2, I2C-1 " \
	"3 Вариант" "  - GPIO-11, UART-3, SPI-2, I2C-1 " \
	"4 Вариант" "  - GPIO-13, UART-1, SPI-2, I2C-2 " \
	"5 Вариант" "  - GPIO-14, UART-1, SPI-2, I2C-1, PWM-1 " \
	"6 Вариант" "  - GPIO-11, UART-3, SPI-1, I2C-1, CAN-Внешний модуль " \
	 3>&1 1>&2 2>&3)

	  RET=$?
	  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
	    interface_menu
	    return 0
	  elif [ $RET -eq 0 ]; then
	    case "$OPTION_F1" in
		1\ *) cp /boot/dtb/sun50i-h5-repka-pi3-1ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		2\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-1ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		3\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-1ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		4\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-i2c2-1ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		5\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-pwm-1ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		6\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-can-1ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
	      *) whiptail --msgbox "Ошибка" 20 60 1 ;;
	    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1
	  fi	

	
if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}

freq_2() {
	OPTION_F2=$(whiptail --title "Максимальная частота 1.2 GHz" --menu "Выберите вариант распиновки портов Repka-Pi" 15 80 8 \
	"1 Вариант" " - GPIO-26, UART-1 (По умолчанию) " \
	"2 Вариант" " - GPIO-15, UART-1, SPI-2, I2C-1 " \
	"3 Вариант" " - GPIO-11, UART-3, SPI-2, I2C-1, " \
	"4 Вариант" " - GPIO-13, UART-1, SPI-2, I2C-2" \
	"5 Вариант" " - GPIO-14, UART-1, SPI-2, I2C-1, PWM-1" \
	"6 Вариант" " - GPIO-11, UART-3, SPI-1, I2C-1, CAN-Внешний модуль " \
	 3>&1 1>&2 2>&3)

	  RET=$?
	  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
	    interface_menu
	    return 0
	  elif [ $RET -eq 0 ]; then
	    case "$OPTION_F2" in
		1\ *) cp /boot/dtb/sun50i-h5-repka-pi3-1.2ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		2\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-1.2ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		3\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-1.2ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		4\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-i2c2-1.2ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		5\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-pwm-1.2ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		6\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-can-1.2ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
	      *) whiptail --msgbox "Ошибка" 20 60 1 ;;
	    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1
	  fi	
	  
	
if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}


freq_3() {
	OPTION_F3=$(whiptail --title "Максимальная частота 1.368 GHz" --menu "Выберите вариант распиновки портов Repka-Pi" 15 80 8 \
	"1 Вариант" " - GPIO-26, UART-1 (По умолчанию) " \
	"2 Вариант" " - GPIO-15, UART-1, SPI-2, I2C-1 " \
	"3 Вариант" " - GPIO-11, UART-3, SPI-2, I2C-1, " \
	"4 Вариант" " - GPIO-13, UART-1, SPI-2, I2C-2" \
	"5 Вариант" " - GPIO-14, UART-1, SPI-2, I2C-1, PWM-1" \
	"6 Вариант" " - GPIO-11, UART-3, SPI-1, I2C-1, CAN-Внешний модуль " \
	 3>&1 1>&2 2>&3)

	  RET=$?
	  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
	    interface_menu
	    return 0
	  elif [ $RET -eq 0 ]; then
	    case "$OPTION_F3" in
		1\ *) cp /boot/dtb/sun50i-h5-repka-pi3-1.4ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		2\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-1.4ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		3\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-1.4ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		4\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-i2c2-1.4ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		5\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-pwm-1.4ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		6\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-can-1.4ghz.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
	      *) whiptail --msgbox "Ошибка" 20 60 1 ;;
	    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1
	  fi	


if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}


freq_4() {
	OPTION_F4=$(whiptail --title "Максимальная частота 1.368 GHz (для печатных плат v1.4 и выше)" --menu "Выберите вариант распиновки портов Repka-Pi" 15 80 8 \
	"1 Вариант" " - GPIO-26, UART-1 (По умолчанию) " \
	"2 Вариант" " - GPIO-15, UART-1, SPI-2, I2C-1 " \
	"3 Вариант" " - GPIO-11, UART-3, SPI-2, I2C-1, " \
	"4 Вариант" " - GPIO-13, UART-1, SPI-2, I2C-2" \
	"5 Вариант" " - GPIO-14, UART-1, SPI-2, I2C-1, PWM-1" \
	"6 Вариант" " - GPIO-11, UART-3, SPI-1, I2C-1, CAN-Внешний модуль " \
	 3>&1 1>&2 2>&3)

	  RET=$?
	  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
	    interface_menu
	    return 0
	  elif [ $RET -eq 0 ]; then
	    case "$OPTION_F4" in
		1\ *) cp /boot/dtb/sun50i-h5-repka-pi3-v1.4.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		2\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-v1.4.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		3\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-v1.4.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		4\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-i2c2-v1.4.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		5\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-pwm-v1.4.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		6\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-can-v1.4.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
	      *) whiptail --msgbox "Ошибка" 20 60 1 ;;
	    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1
	  fi	


if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}


freq_5() {
	OPTION_F5=$(whiptail --title "Максимальная частота 1.368 GHz (для печатных плат v1.4 и выше)" --menu "Выберите вариант распиновки портов Repka-Pi" 15 80 8 \
	"1 Вариант" " - GPIO-26, UART-1 (По умолчанию) " \
	"2 Вариант" " - GPIO-15, UART-1, SPI-2, I2C-1 " \
	"3 Вариант" " - GPIO-11, UART-3, SPI-2, I2C-1, " \
	"4 Вариант" " - GPIO-13, UART-1, SPI-2, I2C-2" \
	"5 Вариант" " - GPIO-14, UART-1, SPI-2, I2C-1, PWM-1" \
	"6 Вариант" " - GPIO-11, UART-3, SPI-1, I2C-1, CAN-Внешний модуль " \
	 3>&1 1>&2 2>&3)

	  RET=$?
	  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
	    interface_menu
	    return 0
	  elif [ $RET -eq 0 ]; then
	    case "$OPTION_F5" in
		1\ *) cp /boot/dtb/sun50i-h5-repka-pi3-v1.4p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		2\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-v1.4p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		3\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-v1.4p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		4\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-i2c2-v1.4p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		5\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-pwm-v1.4p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		6\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-can-v1.4p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
	      *) whiptail --msgbox "Ошибка" 20 60 1 ;;
	    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1
	  fi	


if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}



freq_6() {
	OPTION_F5=$(whiptail --title "Максимальная частота 1.416 GHz (для печатных плат v1.6)" --menu "Выберите вариант распиновки портов Repka-Pi" 15 80 8 \
	"1 Вариант" " - GPIO-26, UART-1 (По умолчанию) " \
	"2 Вариант" " - GPIO-15, UART-1, SPI-2, I2C-1 " \
	"3 Вариант" " - GPIO-11, UART-3, SPI-2, I2C-1, " \
	"4 Вариант" " - GPIO-13, UART-1, SPI-2, I2C-2" \
	"5 Вариант" " - GPIO-14, UART-1, SPI-2, I2C-1, PWM-1" \
	"6 Вариант" " - GPIO-11, UART-3, SPI-1, I2C-1, CAN-Внешний модуль " \
	"7 Вариант" " - GPIO-20, UART-1, I2C-1, I2S " \
	"8 Вариант" " - GPIO-20, UART-1, I2C-1, I2S-PCM5102 " \
	 3>&1 1>&2 2>&3)

	  RET=$?
	  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
	    interface_menu
	    return 0
	  elif [ $RET -eq 0 ]; then
	    case "$OPTION_F5" in
		1\ *) cp /boot/dtb/sun50i-h5-repka-pi3-v1.6.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		2\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-v1.6.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		3\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-v1.6.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		4\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-i2c2-v1.6.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		5\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-pwm-v1.6.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		6\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-can-v1.6.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		7\ *) cp /boot/dtb/sun50i-h5-repka-pi3-i2s-v1.6.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		8\ *) cp /boot/dtb/sun50i-h5-repka-pi3-i2s-pcm5102-v1.6.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
	      *) whiptail --msgbox "Ошибка" 20 60 1 ;;
	    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1
	  fi	


if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}


freq_7() {
	OPTION_F5=$(whiptail --title "Максимальная частота 1.416 GHz (для печатных плат v1.6)" --menu "Выберите вариант распиновки портов Repka-Pi" 15 80 8 \
	"1 Вариант" " - GPIO-26, UART-1 (По умолчанию) " \
	"2 Вариант" " - GPIO-15, UART-1, SPI-2, I2C-1 " \
	"3 Вариант" " - GPIO-11, UART-3, SPI-2, I2C-1, " \
	"4 Вариант" " - GPIO-13, UART-1, SPI-2, I2C-2" \
	"5 Вариант" " - GPIO-14, UART-1, SPI-2, I2C-1, PWM-1" \
	"6 Вариант" " - GPIO-11, UART-3, SPI-1, I2C-1, CAN-Внешний модуль " \
	"7 Вариант" " - GPIO-20, UART-1, I2C-1, I2S " \
	"8 Вариант" " - GPIO-20, UART-1, I2C-1, I2S-PCM5102 " \
	 3>&1 1>&2 2>&3)

	  RET=$?
	  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
	    interface_menu
	    return 0
	  elif [ $RET -eq 0 ]; then
	    case "$OPTION_F5" in
		1\ *) cp /boot/dtb/sun50i-h5-repka-pi3-v1.6p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		2\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-v1.6p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		3\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-v1.6p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		4\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-i2c2-v1.6p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		5\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-pwm-v1.6p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		6\ *) cp /boot/dtb/sun50i-h5-repka-pi3-alt-uart-can-v1.6p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		7\ *) cp /boot/dtb/sun50i-h5-repka-pi3-i2s-v1.6p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
		8\ *) cp /boot/dtb/sun50i-h5-repka-pi3-i2s-pcm5102-v1.6p.dtb /boot/sun50i-h5-repka-pi3.dtb ;;
	      *) whiptail --msgbox "Ошибка" 20 60 1 ;;
	    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1
	  fi	


if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}



#1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111

console_UART0() {
 
    FUN=$(whiptail --title "Repka Pi утилита для настройки (repka-config)" --menu "Включить или отключить вывод сообщений на UART0" 15 80 8 --cancel-button Back --ok-button Select \
	"console-UART0-off " "Отключить вывод сообщений на UART0" \
	"console-UART0-on " "Включить вывод сообщений на UART0" \
      3>&1 1>&2 2>&3)
 
  RET=$?

  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
    return 0
  elif [ $RET -eq 0 ]; then
    case "$FUN" in
      console-UART0-off\ *) boot_tty6 ;;
      console-UART0-on\ *) boot_ttyS0 ON;;
      *) whiptail --msgbox "Ошибка" 20 60 1 || return 0;;
    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1 || return 0
  fi
  
  if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}




interface_menu() {
 
    FUN=$(whiptail --title "Repka Pi утилита для настройки (repka-config)" --menu "Выберите рекомендуемую частоту для вашего экземпляра Repka-Pi" 20 80 10 --cancel-button Back --ok-button Select \
	"Freq1 " "   1.008 Ghz для плат ver 1.2 и 1.3 " \
	"Freq2 " "   1.200 Ghz для плат ver 1.3 " \
	"Freq3 " "   1.368 Ghz для плат ver 1.3 " \
	"Freq4 " "   1.368 Ghz для плат ver 1.4 и 1.5 с активным охлаждением " \
	"Freq5 " "   1.368 Ghz для плат ver 1.4 и 1.5 с пассивным охлаждением" \
	"Freq6 " "   1.416 Ghz для плат ver 1.6 с активным охлаждением " \
	"Freq7 " "   1.416 Ghz для плат ver 1.6 с пассивным охлаждением" \
      3>&1 1>&2 2>&3)
 
  RET=$?
  if [ $RET -eq 1 ]; then
    return 0
  elif [ $RET -eq 0 ]; then
    case "$FUN" in
      Freq1\ *) freq_1 ;;
      Freq2\ *) freq_2 ;;
      Freq3\ *) freq_3 ;;
      Freq4\ *) freq_4 ;;
      Freq5\ *) freq_5 ;;
      Freq6\ *) freq_6 ;;
      Freq7\ *) freq_7 ;;
      *) whiptail --msgbox "Ошибка" 20 60 1 ;;
    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1
  fi
}

#-------------------------------------

gui_console() {	OPTION_F1=$(whiptail --title "Режим запуска операционной системы" --menu "Графический с рабочим столим или в консоле" 15 80 8 \
	"1 GUI" "  - Графический режим, работа в графическом окружении " \
	"2 Console" "  - Консольный режим, работа в коммандной строке " \
	 3>&1 1>&2 2>&3)

	  RET=$?
	  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
	    return 0
	  elif [ $RET -eq 0 ]; then
	    case "$OPTION_F1" in
		1\ *) systemctl set-default graphical.target ;;
		2\ *) systemctl set-default multi-user.target ;;
	      *) whiptail --msgbox "Ошибка" 20 60 1 ;;
	    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1
	  fi	

	
if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}

#-------------------------------------

networkmanager() {
  nmtui &&
  return 0
}


#-------------------------------------

_overclocking() {
 
	CHECKRAM=$(($(getconf _PHYS_PAGES) * $(getconf PAGE_SIZE) / 1048576))
 	if [ $CHECKRAM -lt 1000 ] ; then
 	
     FUN=$(whiptail --title "Repka Pi утилита для настройки (repka-config)" --menu "Настройка тактовых частот" 15 80 8 --cancel-button Back --ok-button Select \
	"DRAM-CLK-672 " "Штатная частота оперативной памяти 672 mHz" \
	"DRAM-CLK-696 " "Частота оперативной памяти 696 mHz" \
	"DRAM-CLK-744 " "Частота оперативной памяти 744 mHz" \
	"DRAM-CLK-768 " "Частота оперативной памяти 768 mHz" \
      3>&1 1>&2 2>&3)
 
	else
 
    FUN=$(whiptail --title "Repka Pi утилита для настройки (repka-config)" --menu "Настройка тактовых частот" 15 80 8 --cancel-button Back --ok-button Select \
	"DRAM-CLK-672 " "Штатная частота оперативной памяти 672 mHz" \
	"DRAM-CLK-696 " "Частота оперативной памяти 696 mHz" \
      3>&1 1>&2 2>&3)
 	
 	fi
  RET=$?

  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
    return 0
  elif [ $RET -eq 0 ]; then
    case "$FUN" in
      DRAM-CLK-672\ *) DRAM_CLK_672 ;;
      DRAM-CLK-696\ *) DRAM_CLK_696 ;;
      DRAM-CLK-744\ *) DRAM_CLK_744 ;;
      DRAM-CLK-768\ *) DRAM_CLK_768 ;;
      *) whiptail --msgbox "Ошибка" 20 60 1 || return 0;;
    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1 || return 0
  fi
  
  if (whiptail --title "Чтобы изменения вступили в силу необходимо перезагрузить Repka-pi3" --yesno "Перезагрузить ?" 10 80) then
    echo "Перезагружаем $?."
      reboot
else
    echo "Ну ок... ^___^ $?."
fi
}

#-------------------------------------

update() {
 echo " А есть ли интернет....хм... ? "
 if ping -c 1 repka-pi.ru > /dev/null 2>&1; then
 echo " ура интернет ^___^ "
  
    FUN=$(whiptail --title "Repka Pi утилита для настройки (repka-config)" --menu "Включить или отключить вывод сообщений на UART0" 15 80 8 --cancel-button Back --ok-button Select \
	"Ubuntu-update " "Обновить пакеты Ubuntu" \
	"Repka-OS-update " "Обновить файлы Repka-OS" \
	"Kernel-update " "Обновить ядро Linux" \
      3>&1 1>&2 2>&3)
 
  RET=$?

  if [ $RET -eq 1 ] || [ $RET -eq 255 ]; then
    return 0
  elif [ $RET -eq 0 ]; then
    case "$FUN" in
      Ubuntu-update\ *) Ubuntu_update ;;
      Repka-OS-update\ *) Repka_OS_update ;;
      Kernel-update\ *) Kernel_update ;;
      *) whiptail --msgbox "Ошибка" 20 60 1 || return 0;;
    esac || whiptail --msgbox "Что то тут не так $FUN" 20 60 1 || return 0
  fi
 
 
else
whiptail --msgbox "Отсутствует подключение к интернету  " 10 40 1 || return 0
fi
  
}



#---------------------------------------------

about() {
  whiptail --msgbox "\
Утилита Repka-config для удобной настройки основных функций одноплатного компьютера Repka-Pi
" 20 70 1
  return 0
}
#---------------------------------------------------------------


#--------------------------------------------------------------------
  while true; do

      FUN=$(whiptail --title "Repka Pi утилита для настройки (repka-config)"  --menu "Выберите настраиваемую опцию" 20 80 10 --cancel-button Finish --ok-button Select \
        "1 console-UART0-on/off" "Включить / отключить вывод сообщений на UART0" \
        "2 Display Options" "Настройка параметров дисплея" \
        "3 Frequency / Pinout Options" "Настройка производительности и распиновки" \
        "4 GUI / Console" "Графическая оболочка или консоль" \
        "5 NetworkManager" "Настройка сети" \
        "6 Overclocking" "Настройка тактовых частот" \
        "7 Update" "Обновление пакетов" \
        "8 About repka-config" "Информация по утилите настройки" \
        3>&1 1>&2 2>&3)

    RET=$?
    if [ $RET -eq 1 ]; then
      do_finish
	  return 0
    elif [ $RET -eq 0 ]; then
      case "$FUN" in
        1\ *) console_UART0 ;;
        2\ *) display_menu ;;
        3\ *) interface_menu ;;
        4\ *) gui_console ;;
        5\ *) networkmanager ;;       
        6\ *) overclocking ;;
        7\ *) update ;;
        8\ *) about ;;
        *) whiptail --msgbox "Ой" 20 60 1 ;;
      esac || whiptail --msgbox "В разработке $FUN" 20 60 1
    else
      exit 1
    fi
  done



#-------------------------------------------------------------------------------------------------------------



